﻿@:expose
class Lattice extends Multiplication {
	public function new(Highlight:Highlight) {
		super(Highlight);
	}

	private override function query_data_mid_detail(kx:Int, ky:Int, id:String) {
		var x = id.substr(2, 1);
		var operation = "";
		if (x == "X") {
			operation += (enable_highlight(mid[ky][kx].lattice_high, 1) + mid[ky][kx].lattice_low);
		} else {
			operation += (mid[ky][kx].lattice_high + enable_highlight(mid[ky][kx].lattice_low, 1));
		}
		operation += "=" + (enable_highlight(input_x[kx], 1) + "×" + enable_highlight(input_y[ky], 1));
		Highlight.markup_detail = operation;
	}

	private override function output_cin(k:Int):Int {
		return (output[k].lattice_cin);
	}

	private override function output_cout(k:Int):Int {
		return (output[k].lattice_cout);
	}

	private override function query_data_output_detail(k:Int, add_carry:String, highlight:Array<String>) {
		var add_list = "";
		var separator = "";
		for (ky2 in 0...(2 * input_y.length)) {
			var ky = Math.floor(ky2 / 2);
			var kx = Math.floor((2 * k - ky2) / 2);
			if ((kx >= 0) && (kx < input_x.length - 1)) {
				var value:Int;
				if (ky2 % 2 == 0) {
					value = mid[ky][kx].lattice_low;
					highlight.push("_mx" + kx + "y" + ky);
				} else {
					value = mid[ky][kx].lattice_high;
					highlight.push("_mX" + kx + "y" + ky);
				}
				add_list += separator + enable_highlight(value, 1);

				separator = "+";
			}
		}

		var operation = (enable_highlight(output[k].lattice_cout, 3) + enable_highlight(output[k].lattice_digit, 1)) + "=" + "(" + add_list + ")"
			+ (output[k].lattice_cin == null ? "" : "+") + enable_highlight(output[k].lattice_cin, 2);
		Highlight.markup_detail = add_carry + "\n" + operation;
	}

	private override function generate_markup_main():String {
		var begin = "<tr><td></td>";
		var body = "";
		var end = "<tr><td></td>";
		for (ikx in 1...input_x.length) {
			var kx = input_x.length - ikx - 1;
			var k = kx;
			begin += "<td>" + generate_markup_id("_ix" + kx, Std.string(input_x[kx])) + " " + "</td>";
			end += "<td>" + generate_markup_id("_o" + k, Std.string(output[k].standard_digit)) + " " + "</td>";
		}
		begin += "<td></td></tr>\n";
		end += "<td></td></tr>";
		for (iky in 0...input_y.length) {
			var ky = input_y.length - iky - 1;
			var k = input_x.length + ky - 1;
			body += "<tr>" + "<td>" + generate_markup_id("_o" + k, Std.string(output[k].standard_digit)) + "</td>";
			for (ikx in 1...input_x.length) {
				var kx = input_x.length - ikx - 1;
				body += "<td>";
				body += "<table>";
				body += "<tr><td>";
				body += generate_markup_id("_mX" + kx + "y" + ky, Std.string(mid[ky][kx].lattice_high));
				body += "</td><td>/</td></tr>";
				body += "<tr><td>/</td><td>";
				body += generate_markup_id("_mx" + kx + "y" + ky, Std.string(mid[ky][kx].lattice_low)) + " ";
				body += "</td></tr>";
				body += "</table>";
				body += "</td>";
			}
			body += "<td>" + generate_markup_id("_iy" + ky, Std.string(input_y[ky])) + "</td>" + "</tr>\n";
		}

		var markup_main = "<table class='lattice'>" + begin + body + end + "</table>";

		return (markup_main);
	}
}
