﻿@:expose
class Standard extends Multiplication {
	public function new(Highlight:Highlight) {
		super(Highlight);
	}

	private override function query_data_input_highlight(variable:String, k:Int, kk:Int, highlight:Array<String>) {
		if (variable == "x") {
			// super.query_data_input_highlight(variable, k, kk, highlight);
		} else {
			super.query_data_input_highlight(variable, k, kk, highlight);
		}
	}

	private override function query_data_input_detail(variable:String, k:Int) {
		if (variable == "x") {
			Highlight.markup_detail = "";
		} else {
			var concat = "";
			for (i in 0...mid[k].length) {
				concat += mid[k][mid[k].length - i - 1].standard_digit;
			}
			var operation = enable_highlight(input_x_str, 1) + "×" + enable_highlight(input_y[k], 1) + "=" + enable_highlight(concat, 1);
			Highlight.markup_detail = operation;
		}
	}

	private override function query_data_mid_detail(kx:Int, ky:Int, id:String) {
		var carry_list = "";
		var carry_in:Null<Int> = null;
		var carry_out:Null<Int> = null;
		var separator = "";
		for (i in 1...input_x.length) {
			var inv = input_x.length - i - 1;
			var enable:Null<Int> = null;
			if (inv == kx - 1) {
				enable = 2;
				carry_in = mid[ky][inv].standard_cout;
			}
			if (inv == kx) {
				enable = 3;
				carry_out = mid[ky][inv].standard_cout;
			}
			carry_list += separator + enable_highlight(mid[ky][inv].standard_cout, enable);
			separator = ",";
		}
		var operation = (carry_out == null ? "" : enable_highlight(mid[ky][kx].standard_cout, 3))
			+ enable_highlight(mid[ky][kx].standard_digit, 1)
			+ "="
			+ (kx < input_x.length - 1 ? (enable_highlight(input_x[kx], 1) + "×" + enable_highlight(input_y[ky], 1)) : "")
			+ ((kx < input_x.length - 1) && (carry_in != null) ? "+" : "")
			+ enable_highlight(mid[ky][kx].standard_cin, 2);

		var mult_carry = markup_carry("Multiplication", ky + 1, kx + 1, carry_in, carry_out, carry_list);

		Highlight.markup_detail = mult_carry + "\n" + operation;
	}

	private override function output_cin(k:Int):Int {
		return (output[k].standard_cin);
	}

	private override function output_cout(k:Int):Int {
		return (output[k].standard_cout);
	}

	private override function query_data_output_detail(k:Int, add_carry:String, highlight:Array<String>) {
		var add_list = "";
		var separator = "";
		for (ky in 0...input_y.length) {
			var kx = (k - ky);
			if ((kx >= 0) && (kx < input_x.length)) {
				highlight.push("_mx" + (k - ky) + "y" + ky);
				add_list += separator + enable_highlight(mid[ky][kx].standard_digit, 1);
				separator = "+";
			}
		}

		var operation = (enable_highlight(output[k].standard_cout, 3) + enable_highlight(output[k].standard_digit, 1)) + "=" + ("(" + add_list + ")")
			+ (output[k].standard_cin == null ? "" : "+") + enable_highlight(output[k].standard_cin, 2);
		Highlight.markup_detail = add_carry + "\n" + operation;
	}

	private override function generate_markup_main():String {
		var markup_main = "";

		markup_main += generate_markup_input(input_x, "x", 1);
		markup_main += "\n&times; ";
		markup_main += generate_markup_input(input_y, "y", 0);
		markup_main += "<hr/>";

		markup_main += generate_markup_mid();
		markup_main += "<hr/>";

		markup_main += generate_markup_output();

		return (markup_main);
	}

	private function generate_markup_input(input:Array<Int>, symbol:String, offset:Int):String {
		var markup_main = "";
		for (kx in offset...input.length) {
			var id = input.length - kx - 1;
			markup_main += generate_markup_id("_i" + symbol + id, Std.string(input[id]));
		}
		return (markup_main);
	}

	private function generate_markup_output():String {
		var markup_main = "";

		for (k in 1...output.length) {
			var inv = output.length - k - 1;
			var value = output[inv].standard_digit;
			markup_main += generate_markup_id("_o" + inv, Std.string(output[inv].standard_digit));
		}
		return (markup_main);
	}

	private function generate_markup_mid():String {
		var markup_main = "";
		var ident = "";
		for (ky in 0...input_y.length) {
			for (k in 0...(input_x.length + input_y.length)) {
				var id = input_x.length - (k - ky) - 1;
				if ((id >= 0) && (id < input_x.length)) {
					markup_main += "<span id='_mx" + id + "y" + ky + "'>" + mid[ky][id].standard_digit + "</span>";
				}
			}
			markup_main += ident + "\n";
			ident += " ";
		}

		return (markup_main);
	}
}
