var Highlight;
var mouse_over = 0;
var mouse_out = 0;

function onload(mode) {
	Highlight = new Highlight();

	if (location.hash != null && location.hash.length > 0) {
		var list = location.hash.substr(1).split(/[&]/);
		for (l in list) {
			var k = list[l].substr(0, 1);
			var v = list[l].substr(2);
			switch (k) {
				case "m":
					mode = "Standard";
					if (v == "Lattice") {
						mode = v;
					}
					break;
				case "x":
					document.getElementById("x").value = v;
					break;
				case "y":
					document.getElementById("y").value = v;
					break;
			}
		}
	}

	updateHighlight(mode);
}
function updateHighlight(mode) {
	var x = document.getElementById("x").value;
	var y = document.getElementById("y").value;
	Highlight.process_data(x, y, mode);
	document.getElementById("main").innerHTML = Highlight.markup_main;
	document.getElementById("overview").innerHTML = Highlight.markup_overview_default;
	document.getElementById("mode").innerHTML = mode;
	updateMarkup();
	updateLocation(mode, x, y);
}

function updateLocation(mode, x, y) {
	var current = location.pathname.split('/').pop();
	var file = mode + ".html";
	var hash = "x=" + x + "&y=" + y;
	if (current == file) {
		location.hash = hash;
	} else {
		location = "./" + file + "#" + hash;
	}
}

function updateMarkup() {
	var myNodelist = document.querySelectorAll('[id^=_]');
	for (var i = 0; i < myNodelist.length; i++) {
		myNodelist[i].addEventListener("mouseover", function_mouseover);
		myNodelist[i].addEventListener("mouseout", function_mouseout);
		myNodelist[i].title = "";
	}
}

function function_mouseover(event) {
	mouse_over++;
	var id = event.target.id;
	Highlight.query_data(id);
	var highlight = Highlight.highlight;
	for (var i = 0; i < highlight.length; i++) {
		var d = document.getElementById(highlight[i]);
		if (d != null) {
			document.getElementById(highlight[i]).style.cssText = style_highlight1;
		}
	}
	update_detail(Highlight.markup_detail);
}

function function_mouseout(event) {
	mouse_out++;
	var myNodelist = document.querySelectorAll('[id^=_]');
	for (var i = 0; i < myNodelist.length; i++) {
		myNodelist[i].style.cssText = style_none;
	}
	setTimeout(clear_detail, 1500, mouse_out);
}

function clear_detail(mouse_out) {
	if (mouse_out >= mouse_over) {
		update_detail("");
	}
}

function update_detail(detail) {
	document.getElementById("detail").innerHTML = detail;
}

